" Vim syntax file
" Language:	vJASS
" Maintainer:	James Nhan <hero-of-winds@hotmail.com>
" Last Change:  2009 Spet 13
" based on asm.vim

" For version 5.x: Clear all syntax items
" For version 6.x: Quit when a syntax file was already loaded
if version < 600
  syntax clear
elseif exists("b:current_syntax")
  finish
endif

"syn case ignore

" storage types
syn keyword jassType agent
syn keyword jassType hashtable
syn keyword jassType integer
syn keyword jassType string
syn keyword jassType real
syn keyword jassType boolean
syn keyword jassType code
syn keyword jassType handle
syn keyword jassType unit
syn keyword jassType timer
syn keyword jassType group
syn keyword jassType trigger
syn keyword jassType player
syn keyword jassType rect
syn keyword jassType location
syn keyword jassType ability
syn keyword jassType aidifficulty 
syn keyword jassType alliancetype
syn keyword jassType attacktype
syn keyword jassType blendmode
syn keyword jassType boolexpr
syn keyword jassType buff
syn keyword jassType button
syn keyword jassType camerafield
syn keyword jassType camerasetup
syn keyword jassType conditionfunc
syn keyword jassType damagetype
syn keyword jassType defeatcondition
syn keyword jassType destructable
syn keyword jassType dialog
syn keyword jassType dialogevent
syn keyword jassType effect
syn keyword jassType effectype
syn keyword jassType event
syn keyword jassType eventid
syn keyword jassType fgamestate
syn keyword jassType filterfunc
syn keyword jassType fogmodifier
syn keyword jassType fogstate
syn keyword jassType force
syn keyword jassType gamecache
syn keyword jassType gamedifficulty
syn keyword jassType gameevent
syn keyword jassType gamespeed
syn keyword jassType gamestate
syn keyword jassType gametype
syn keyword jassType igamestate
syn keyword jassType image
syn keyword jassType item
syn keyword jassType itempool
syn keyword jassType itemtype
syn keyword jassType leaderboard
syn keyword jassType lightning
syn keyword jassType limitop
syn keyword jassType mapcontrol
syn keyword jassType mapdensity
syn keyword jassType mapflag
syn keyword jassType mapsetting
syn keyword jassType mapvisibility
syn keyword jassType multiboard
syn keyword jassType multiboarditem
syn keyword jassType pathingtype
syn keyword jassType placement
syn keyword jassType playercolor
syn keyword jassType playerevent
syn keyword jassType playergameresult
syn keyword jassType playerslotstate 
syn keyword jassType playerscore
syn keyword jassType playerstate
syn keyword jassType playerunitevent
syn keyword jassType quest
syn keyword jassType questitem
syn keyword jassType race
syn keyword jassType racepreference
syn keyword jassType raritycontrolt
syn keyword jassType region
syn keyword jassType sound
syn keyword jassType soundtype
syn keyword jassType startlocprio
syn keyword jassType terraindeformation
syn keyword jassType texmapflags
syn keyword jassType texttag
syn keyword jassType timerdialog
syn keyword jassType trackable
syn keyword jassType triggeraction
syn keyword jassType triggercondition
syn keyword jassType ubersplat
syn keyword jassType unitevent
syn keyword jassType unitpool
syn keyword jassType unitstate
syn keyword jassType unittype
syn keyword jassType version
syn keyword jassType volumegroup
syn keyword jassType weapontype
syn keyword jassType weathereffect
syn keyword jassType effecttype
syn keyword jassType widget
syn keyword jassType widgetevent
syn keyword jassType nothing 
syn keyword jassType array
syn keyword jassType key
syn keyword jassType thistype

syn match jassIdentifier		"[a-zA-Z][a-zA-Z0-9_]*"
syn match jassBraces display '[ { } ( ) ]'
syn match vjassStruct '[ \[ \] ]'

"syn match decNumber		"0\+[1-7]\=[\t\n$; ]"
syn match decNumber display		"\.[0-9]\d*"
syn match decNumber display "\<\%(0[dD]\)\=\%(0\|[1-9]\d*\%(_\d\+\)*\)\>"
syn match decNumber display "\<\%(0\|[1-9]\d*\%(_\d\+\)*\)\.\d\+\%(_\d\+\)*\>"
syn match decNumber display "[]\=\<\d[[:digit:]_]*\.[[:digit:]_]*\([eE][\-+]\=\d\+\)\="
syn match octNumber display	"0[0-7][0-7]\+"
syn match hexNumber display	"0[xX][0-9a-fA-F]\+"
syn match hexNumber display	"$[0-9a-fA-F]\+"

syn region	jassString		start=+L\="+ skip=+\\\\\|\\"+ end=+"+ contains=cSpecial,@Spell

"syn match binNumber		"0[bB][0-1]*"

syn match jassCondOperator display '[== != < > <= >= + \- * / ,]'
syn match jassComment		"//.*" contains=@Spell


syn match jassPreprocessor      "//![ \t][ \t]*[a-zA-Z].*"

syn keyword jassPreprocessorKeyword debug

syn keyword jassOperator and or not

syn keyword jassCond		if
syn keyword jassCond		elseif
syn keyword jassCond		else
syn keyword jassCond		endif
syn keyword jassCond		then

syn keyword jassLabel		takes
syn keyword jassLabel		returns
syn keyword jassLabel	        defaults
syn keyword jassLabel           null

syn keyword jassFunc		function library library_once initializer requires needs uses scope struct method static interface operator stub module endmodule implement optional
syn keyword jassFunc		endfunction endlibrary endscope endstruct endmethod endinterface
syn keyword jassFunc		globals
syn keyword jassFunc		endglobals

syn keyword jassStatement	return native constant type extends local private public delegate readonly
syn keyword jassStatement	returns
syn keyword jassStatement	takes
syn keyword jassStatement	exitwhen
syn keyword jassStatement	call threaded
syn keyword jassStatement	set
syn keyword jassStatement       hook
syn keyword jassRepeat		loop
syn keyword jassRepeat		endloop

syn keyword jassNative		ConvertRace ConvertAllianceType ConvertRacePref ConvertIGameState ConvertFGameState ConvertPlayerState ConvertPlayerScore ConvertPlayerGameResult ConvertUnitState ConvertAIDifficulty ConvertGameEvent ConvertPlayerEvent ConvertPlayerUnitEvent ConvertWidgetEvent ConvertDialogEvent ConvertUnitEvent ConvertLimitOp ConvertUnitType ConvertGameSpeed ConvertPlacement ConvertStartLocPrio ConvertGameDifficulty ConvertGameType ConvertMapFlag ConvertMapVisibility ConvertMapSetting ConvertMapDensity ConvertMapControl
syn keyword jassNative		Deg2Rad Rad2Deg Sin Cos Tan Asin Acos Atan Atan2 Returns0ifx<0 SquareRoot Pow I2R R2I I2S R2S R2SW S2I S2R GetHandleId SubString StringLength StringCase StringHash GetLocalizedString GetLocalizedHotkey SetMapName SetMapDescription SetTeams SetPlayers DefineStartLocation DefineStartLocationLoc SetStartLocPrioCount SetStartLocPrio GetStartLocPrioSlot GetStartLocPrio SetGameTypeSupported SetMapFlag SetGamePlacement SetGameSpeed SetGameDifficulty SetResourceDensity SetCreatureDensity GetTeams GetPlayers
syn keyword jassNative		IsGameTypeSupported GetGameTypeSelected IsMapFlagSet GetGamePlacement GetGameSpeed GetGameDifficulty GetResourceDensity GetCreatureDensity GetStartLocationX GetStartLocationY GetStartLocationLoc SetPlayerTeam SetPlayerStartLocation ForcePlayerStartLocation SetPlayerColor SetPlayerAlliance SetPlayerTaxRate SetPlayerRacePreference SetPlayerRaceSelectable SetPlayerController SetPlayerName SetPlayerOnScoreScreen GetPlayerTeam GetPlayerStartLocation GetPlayerColor GetPlayerSelectable GetPlayerController
syn keyword jassNative		GetPlayerSlotState GetPlayerTaxRate IsPlayerRacePrefSet GetPlayerName CreateTimer DestroyTimer TimerStart TimerGetElapsed TimerGetRemaining TimerGetTimeout PauseTimer ResumeTimer GetExpiredTimer CreateGroup DestroyGroup GroupAddUnit GroupRemoveUnit GroupClear GroupEnumUnitsOfType GroupEnumUnitsOfPlayer GroupEnumUnitsOfTypeCounted GroupEnumUnitsInRect GroupEnumUnitsInRectCounted GroupEnumUnitsInRange GroupEnumUnitsInRangeOfLoc GroupEnumUnitsInRangeCounted GroupEnumUnitsInRangeOfLocCounted GroupEnumUnitsSelected
syn keyword jassNative		GroupImmediateOrder GroupImmediateOrderById GroupPointOrder GroupPointOrderLoc GroupPointOrderById GroupPointOrderByIdLoc GroupTargetOrder GroupTargetOrderById ForGroup FirstOfGroup CreateForce DestroyForce ForceAddPlayer ForceRemovePlayer ForceClear ForceEnumPlayers ForceEnumPlayersCounted ForceEnumAllies ForceEnumEnemies ForForce Rect RectFromLoc RemoveRect SetRect SetRectFromLoc MoveRectTo MoveRectToLoc GetRectCenterX GetRectCenterY GetRectMinX GetRectMinY GetRectMaxX GetRectMaxY CreateRegion RemoveRegion
syn keyword jassNative		RegionAddRect RegionClearRect RegionAddCell RegionAddCellAtLoc RegionClearCell RegionClearCellAtLoc GetFilterUnit GetEnumUnit GetFilterDestructable GetEnumDestructable GetFilterItem GetEnumItem GetFilterPlayer GetEnumPlayer GetTriggeringTrigger GetTriggerEventId GetTriggerEvalCount GetTriggerExecCount ExecuteFunc And Or Not Condition DestroyCondition Filter DestroyFilter DestroyBoolExpr TriggerRegisterVariableEvent TriggerRegisterTimerExpireEvent, TriggerRegisterGameStateEvent TriggerRegisterDialogEvent
syn keyword jassNative		Location RemoveLocation MoveLocation GetLocationX GetLocationY GetLocationZ IsUnitInRegion IsPointInRegion IsLocationInRegion GetWorldBounds CreateTrigger DestroyTrigger ResetTrigger EnableTrigger DisableTrigger IsTriggerEnabled TriggerWaitOnSleeps IsTriggerWaitOnSleeps TriggerRegisterDialogButtonEvent GetEventGameState TriggerRegisterGameEvent GetWinningPlayer TriggerRegisterEnterRegion TriggerRegisterLeaveRegion GetLeavingUnit TriggerRegisterTrackablehitEvent TriggerRegisterTrackableTrackEvent
syn keyword jassNative		GetTriggeringTrackable GetClickedButton GetClickedDialog GetTournamentFinishSoonTimeRemaining GetTournamentFinishNowRule GetTournamentFinishNowPlayer GetTournamentScore GetSaveBasicFilename TriggerRegisterPlayerEvent GetTriggerPlayer TriggerRegisterPlayerUnitEvent GetLevelingUnit GetLearningUnit GetLearnedSkill GetLearnedSkillLevel GetRevivableUnit GetRevivingUnit GetAttacker GetRescuer GetDyingUnit GetKillingUnit GetDecayingUnit GetConstructingStructure GetCancelledStructure GetConstructedStructure
syn keyword jassNative		GetResearchingUnit GetResearched GetTrainedUnitType GetTrainedUnit GetDetectedUnit GetSummoningUnit GetSummonedUnit GetTransportUnit GetLoadedUnit GetSellingUnit GetSoldUnit GetBuyingUnit GetSoldItem GetChangingUnit GetChangingUnitPrevOwner GetManipulatingUnit GetManipulatedItem GetOrderedUnit GetIssuedOrderId GetOrderPointX GetOrderPointY GetOrderPointLoc GetOrderTarget GetOrderTargetDestructable GetOrderTargetitem GetOrderTargetUnit GetSpellAbilityUnit GetSpellAbilityId GetSpellAbility GetSpellTargetLoc
syn keyword jassNative		GetSpellTargetX GetSpellTargetY GetSpellTargetDestructable GetSpelLTargetItem GetSpelLTargetUnit TriggerRegisterPlayerAllianceChange TriggerRegisterPlayerStateEvent GetEventPlayerState TriggerRegisterPlayerChatEvent GetEventPlayerChatString GetEventPlayerChatStringMatched Trigger RegisterDeathEvent GetTriggerunit TriggerRegister UnitStateEvent GetEventUnitState TirggerRegisterUnitEvent GetEventDamage GetEventDamageSource GetEventDetectingPlayer TriggerRegisterFilterUnitEvent GetEventTargetUnit
syn keyword jassNative		TriggerRegisterUnitInRange TriggerAddCondition TriggerRemoveCondition TriggerClearConditions TriggerAddAction TriggerRemoveAction TriggerClearActions TriggerSleepAction TriggerWaitForSound TriggerEvaluate TriggerExecute TriggerExecuteWait TriggerSyncStart TriggerSyncReady GetWidgetLife SetWidgetLife GetWidgetX GetWidgetY GetTriggerWidget CreateDestructable CreateDestructableZ CreateDeadDestructable CreateDeadDestructableZ RemoveDestructable KillDestructable SetDestructableInvulnerable IsDestructableInvulnerable
syn keyword jassNative		EnumDestructablesInRect GetDestructableTypeId GetDestructableX GetDestructableY SetDestructableLife GetDestructableLife SetDestructableMaxLife GetDestructableMaxLife DestructableRestoreLife QueueDestructableAnimation SetDestructableAnimation SetDestructableAnimationSpeed ShowDestructable GetDestructableOccluderHeight SetDestructableOccluderHeight GetDestructableName GetTriggerDestructable CreateItem RemoveItem GetItemPlayer GetItemTypeId GetItemX GetItemY SetItemPosition SetItemDropOneath SetItemDroppable
syn keyword jassNative		SetItemPawnable SetItemPlayer SetItemInvulnerable IsItemInvulnerable SetItemVisible IsItemVisible IsItemOwned IsItemPowerup IsItemSellable IsItemPawnable IsItemIdPowerup IsItemidSellable IsItemIdPawnable EnumItemsInRect GetItemLevel GetItemType GetitemDropID GetItemName GetItemCharges SetItemCharges GetItemUserData SetItemUserData CreateUnit CreateUnitByName CreateUnitAtLoc CreateUnitAtLocByName CreateCorpse KillUnit RemoveUnit ShowUnit SetUnitState SetUnitX SetUnitY SetUnitPosition SetUnitPositionLoc
syn keyword jassNative		SetUnitFacing SetunitFacingTimed SetUnitMoveSpeed SetUnitFlyHeight SetUnitTurnSpeed SetUnitPropWindow SetUnitAcquireRange SetUnitCreepGuard GetUnitAcquireRange GetUnitTurnSpeed GetUnitPropWindow GetUnitFlyHeight GetUnitDefaultAcquireRange GetUnitDefaultTurnSpeed GetUnitDefaultPropWindow GetUnitDefaultFlyHeight SetUnitOwner SetUnitColor SetUnitScale SetUnitTimeScale SetUnitBlendTime SetUnitVertexColor QueueUnitAnimation SetUnitAnimation SetUnitAnimationByIndex SetUnitAnimationWithRarity AddUnitAnimationProperties
syn keyword jassNative		SetUnitLookAt ResetUnitLookAt SetUnitRescuable SetUnitRescueRange SetHeroStr SetHeroAgi SetHeroInt GetHeroStr GetHeroAgi GetHeroInt UnitStripHeroLevel GetHeroXP SetHeroXP GetHeroSkillPoints UnitModifySkillPoints AddHeroXP SetHeroLevel GetHeroLevel GetUnitLevel GetHeroPropername SuspendHeroXP IsSuspendedXP SelectHeroSkill GetUnitAbilityLevel DecUnitAbilityLevel IncUnitAbilityLevel SetUnitAbilityLevel ReviveHero ReviveHeroLoc SetUnitExpoded SetUnitInvulnerable PauseUnit IsUnitPaused SetUnitPathing ClearSelection
syn keyword jassNative		SelectUnit GetUnitPointValue GetUnitPointValueByType UnitAddItem UnitAddItemById UnitAddItemToSlotByid UnitRemoveItem UnitRemoveItemFromSlot UnitHasItem UniItemInSlot UnitInventorySize UnitDropItemPoint UnitDropItemSlot UnitDropItemTarget UnitUseItem UnitUseItemPoint UnitUseItemTarget GetUnitX GetUnitY GetUnitLoc GetUnitFacing GetUnitMoveSpeed GetUnitDefaultMoveSpeed GetUnitState GetOwningPlayer GetUnitTypeId GetUnitRace GetUnitName GetUnitFoodUsed GetUnitFood Made GetFoodmade GetFoodUsed SetUnitUseFood
syn keyword jassNative		GetUnitRallyPoint GetUnitRallyUnit GetUnitRallyDestructable IsUnitInGroup IsUnitInForce IsUnitOwnedByPlayer IsUnitAlly IsUnitEnemy IsUnitVisible IsUnitDetected IsUnitInvisible IsunitDetected IsUnitFogged IsUnitMasked IsUnitSelected isUnitRace IsUnitType IsUnit IsUnitInRange IsUnitInRangeXY IsUnitInRangeLoc IsUnitHidden IsUnitIllusion IsUnitInTranspot IsUnitLoaded IsHeroUnitId IsUnitIdType UnitShareVision UnitSuspendDecay UnitAddType UnitRemoveType UnitAddAbility UnitRemoveAbility UnitMakeAbilityPermanent
syn keyword jassNative		UnitRemoveBuffs UnitRemoveBuffsEx UnitHasBuffsEx UnitCountBuffsEx UnitAddSleep UnitCanSleep UnitAddSleepPerm UnitCanSleepPerm UnitIsSleeping UnitWakeUp UnitApplyTimedLife UnitIgnoreAlarm UnitIgnoreAlarmToggled UnitResetCooldown UnitSetConstructionProgress UnitSetUpgradeProgress UnitpauseTiemdLife UnitSetUsesAltIcon UnitDamagePoint UnitDamageTarget IssueImmediateOrder IssueImmediateOrderById IssuePointOrder IssuePointOrderLoc IssuePointOrderById IssuePointOrderByIdLoc IssueTargetOrder IssueTargetOrderById
syn keyword jassNative		IssueInstantPointOrder IssueInstantPointOrderId IssueInstantTargetOrder IssueInstantTargetOrderById IssueBuildOrder IssueBuildOrderById IssueNeutralImmediateOrder IssueNeutralImmediateOrderByid IssueNeutralPointOrder IssueNeutralPointOrderById IssueNeutralTargetOrder IssueNeutralTargetOrderById GetUnitCurrentOrder SetResourceAmount AddResourceAmount GetResourceAmount WaygateGetDestinationX WaygateGetDestinationY WaygateSetDestination WaygateActive WaygateIsActive AddItemToAllStock AddItemToStock AddUnitToAllStock
syn keyword jassNative		AddUnitToStock RemoveItemFromAllStock RemoveItemFromStock RemoveUnitFromAllStock RemoveUnitFromStock SetAllItemTypeSlots SetAllUnitTypeSlots SetItemTypeSlots SetUnitTypeSlots GetUnitUserData SetUnitUserData Player GetLocalPlayer IsPlayerAlly IsPlayerEnemy IsPlayerInForce IsPlayerObserver IsVisibleToPlayer IsLocationVisibleToPlayer IsFoggedToPlayer IsLocationFoggedToPlayer IsMaskedToPlayer IsLocationMaskedToPlayer GetPlayerRace GetPlayerId GetPlayerUnitcount GetPlayerTypedUnitCount GetPlayerStructureCount
syn keyword jassNative		GetPlayerState GetPlayerScore GetPlayerAlliance GetPlayerHandicap GetPlayerHandicapXP SetPlayerHandicap SetPlayerHandicapXP SetPlayerTechMaxAllowed GetPlayerTechMaxAllowed AddPlayerTechResearched SetPlayerTechResearched GetPlayerTechResearched GetPlayerTechCount SetPlayerUnitsOwner CripplePlayer SetPlayerAbilityAvailable SetPlayerState RemovePlayer CachePlayerHeroData SetFogStateRect SetFogStateRadius SetFogStateRadiusLoc FogMaskEnable IsFogMaskEnabled FogEnable IsFogEnabled CreateFogModifierRect
syn keyword jassNative		CreateFogModifierRadius CreateFogModifierRadiusLoc DestroyFogModifier FogModifierStart FogModifierStop VersionGet VersionCompatible VersionSupported EndGame ChangeLevel RestartGame ReloadGame SetCampaignMenuRace SetCampaignMenuRaceEx ForceCampaignSelectScreen LoadGame SaveGame RenameSaveDirectory RemoveSaveDirectory CopySaveGame SaveGameExists SynkSelections SetFloatGameState GetFloatGameState SetIntegerGameStates GetIntegerGameState SetTutorialCleared SetMissionAvailable SetCampaignAvailable
syn keyword jassNative		SetOpCinematicAvailable SetEdCinematicAvailable GetEDefaultDifficulty SetDefaultDifficulty SetCustomCampaignButtonVisible GetCustomCampaignButtonVisible DoNotSaveReplay DialogCreate DialogDestroy DialogClear DialogSetMessage DialogAddMessage DialogAddButton DialogAddQuitButton DialogDisplay ReloadGameCachesFromDisk InitGameCache SaveGameCache StoreInteger StoreReal StoreBoolean StoreUnit StoreString SyncStoredInteger SyncStoredReal SyncStoredBoolean SyncStoredUnit SyncStoredString HaveStoredInteger
syn keyword jassNative		HaveStoredReal HaveStoredBoolean HaveStoredUnit HaveStoredString FlushGameCache FlushStoredMission FlusheStoredInteger FlushStoredReal FlushStoredBoolean FlushStoredUnit FlushStoredString GetStoredInteger GetStoredReal GetStoredBoolean GetStoredString RestoreUnit InitHashtable SaveInteger SaveReal SaveBoolean SaveStr SavePlayerHandle SaveWidgetHandle SaveDestructableHandle SaveItemHandle SaveUnitHandle SaveAbilityHandle SaveTimerHandle SaveTriggerhandle SaveTriggerConditionhandle SaveTriggerActionHandle
syn keyword jassNative		SaveTriggerEventHandle SaveForceHandle SaveGroupHandle SaveLocationhandle SaveRectHandle SaveBooleanExprhandle SaveSoundHandle SaveEffectHandle SaveUnitPoolhandle SaveItemPoolHandle SaveQuestHandle SaveQuestItemhandle SaveDefeatConditionHandle SaveTimerDialogHandle SaveLeaderboardHandle SaveMultiboardHandle SaveMultiboardItemhandle SaveTrackableHandle SaveDialogHandle SaveButtonhandle SaveTextTaghandle SaveLightningHandle SaveImageHandle SaveUbersplatHandle SaveRegionHandle SaveFogStatehandle SaveFogModifierhandle
syn keyword jassNative		SaveAgentHandle SaveHashtableHandle LoadInteger LoadReal LoadBoolean LoadStr LoadPlayerHandle LoadWidgetHandle LoadDestructableHandle LoadItemHandle LoadUnitHandle LoadAbilityHandle LoadTimerHandle LoadTriggerhandle LoadTriggerConditionhandle LoadTriggerActionHandle LoadTriggerEventHandle LoadForceHandle LoadGroupHandle LoadLocationhandle LoadRectHandle LoadBooleanExprhandle LoadSoundHandle LoadEffectHandle LoadUnitPoolhandle LoadItemPoolHandle LoadQuestHandle LoadQuestItemhandle LoadDefeatConditionHandle
syn keyword jassNative		LoadTimerDialogHandle LoadLeaderboardHandle LoadMultiboardHandle LoadMultiboardItemhandle LoadTrackableHandle LoadDialogHandle LoadButtonhandle LoadTextTaghandle LoadLightningHandle LoadImageHandle LoadUbersplatHandle LoadRegionHandle LoadFogStatehandle LoadFogModifierhandle LoadAgentHandle LoadHashtableHandle HaveSavedInteger HaveSavedReal HaveSavedBoolean HaveSavedString HaveSavedHandle RemoveSavedInteger RemoveSavedReal RemoveSavedBoolean RemoveSavedString RemoveSavedHandle FlushParentHasthable FlushChldHashtable
syn keyword jassNative		GetRandomInt GetRandomReal CreateUnitPool DestroyUnitPool UnitPoolAddUnitType UnitPooLRemoveUnitType PlaceRandomUnit CreateItemPool DestroyItemPool ItemPoolAddItemType ItemPoolRemoveItemType PlaceRandomItem ChooseRandomCreep ChooseRandomNPBuilding ChooseRandomItem ChooseRandomItemEx SetRandomSeed SetTerrainFog ResetTerrainFog SetUnitFog SetTerrainFogEx DisplayTextToPlayer DisplayTimedTextToPlayer DisplayTimedTextFromPlayer ClearTextMessages SetDayNightModels SetSkyModel EnableUserControl EnableUserUI
syn keyword jassNative		SuspendTimeOfDay SetTimeOfDayScale GetTimeOfDayScale ShowInterface PauseGame UnitAddIndicator AddIndicator PingMinimap PingMinimapEx EnableOcclusion SetIntroShotText SetIntroShotModel EnableWorldFogBoundary PlayModelCinematic ForceUIKey ForceUICancel DisplayLoadDialog SetAltMinimapIcon DisableRestartMission CreateTextTag DestroyTextTag SetTextTagText SetTextTagPos SetTextTagPosUnit SetTextTagColor SetTextTagVelocity SetTextTagVisibility SetTextTagSuspended SetTextTagPermanent SetTextTagAge SetTextTagLifespawn
syn keyword jassNative		SetTextTagFadepoint SetReservedLocalHeroButtons GetAllyColorFilterState SetAllyColorFilterState GetCreepCampFilterState SetCreepCampFilterState EnableMinimapFilterButtons EnableDragSelect EnablePreSelect EnableSelect CreateTrackable CreateQuest DestroyQuest QuestSetTitle QuestSetDescription QuestSetIconPath QuestSetRequired QuestSetCompleted QuestSetDiscovered QuestSetFailed QuestSetEnabled IsQuestRequired IsQuestCompleted IsQuestDiscovered IsQuestFailed IsQuestEnabled QuestCreateItem QuestItemSetDescription
syn keyword jassNative		QuestItemSetCompleted IsQuestItemCompleted CreateDefeatCondition DestroyDefeatCondition DefeatConditionSetDescription FlashQuestDialogButton ForceQuestDialogUpdate CreateTimerDialog DestroyTimerDialog TimerDialogSetTitle TimerDialogSetTitleColor TimerDialogSetTimeColor TimerDialogSetSpeed TiemrDialogDisplay IsTimerDialogDisplayed TimerDialogSetRealTimeRemaining CreateLeaderboard DestroyLeaderboard LeaderboardDisplay IsLeaderboardDisplayed LeaderboardGetItemCount LeaderboardSetSizeByItemCount LeaderboardAddItem
syn keyword jassNative		LeaderboardRemoveItem LeaderboardRemovePlayerItem LeaderboardClear LeaderboardSortItemsByValue LeaderboardSortItemsByPlayer LeaderboardSortItemsByLabel LeaderboardhasPlayerItem LeaderboardGetPlayerIndex LeaderboardSetLabel LeaderboardGetLabelText PlayerSetLeaderboard PlayerGetLeaderboard LeaderboardLabelColor LeaderboardSetValueColor LeaderboardSetStyle LeaderboardSetItemValue LeaderboardSetItemLabel LeaderboardSetItemStyle LeaderboardSetItemLabelColor LeaderboardSetItemValueColor CreateMultiboard DestroyMultiboard
syn keyword jassNative		MultiboardDisplay IsMultiboardDisplayed MultiboardMinimize IsMultiboardMinimized MultiboardClear MultiboardSetTitleText MultiboardGetTitleText MultiboardSetTitleTextColor MultiboardGetRowCount MultiboardSetColumnCount MultiboardSetRowCount MultiboardSetItemsStyle MultbiardSetItemsValue MultiboardSetItemsValueColor MultiboardSetItemsWidth MultiboardSetItemsIcon MultiboardGetItem MultiboardReleaseItem MultiboardSetitemStyle MultiboardSetItemValue MultiboardSetitemValueColor MultiboardSetItemWidth MultiboardSetItemIcon
syn keyword jassNative		MultiboardSuppressDisplay SetCameraPosition SetCameraQuickPosition SetCameraBounds StopCamera ResetToGameCamera PanCameraTo PanCameraToTimed PanCameraToWithZ PancameraToTimedWithZ SetCinematicCamera SetCameraRotateMode SetCameraField AdjustCameraField SetCameraTargetController SetCameraOrientController CreateCameraSetup CameraSetupSetField CameraSetupGetField CameraSetupSetDestPosition CameraSetupGetDestPositionLoc CameraSetupGetDestPositionX CameraSetupGetDestPositionY CameraSetupApply CameraSetupApplyWithZ
syn keyword jassNative		CameraSetupApplyForceDuration CameraSetupApplyForceDurationWithZ CameraSetTargetNoise CameraSetSourceNoise CameraSetTargetNoiseEx CameraSetSourceNoiseEx CameraSetSmoothingFactor SetCineFilterFeature SetCineFilterBlendMode SetCineFilterTexMapFlags SetCineFilterStartUV SetCineFilterEndUV SetCineFilterStartColor SetCineFilterEndColor SetCineFilterDuration DisplayCineFilter IsCineFilterDisplayed SetCinematicScene EndCinematicScene ForceCinematicSubtitles GetCameraMargin GetCameraBoundMinX GetCameraBoundMinY
syn keyword jassNative		GetCameraBoundMaxX GetCameraBoundMaxY GetCameraField GetCameraTargetPositionX GetCameraTargetPositionY GetCameraTargetPositionZ GetCameraTargetPositionLoc GetCameraEyePositionX GetCameraEyePositionY GetCameraEyePositionZ GetCameraEyePositionLoc NewSoundEnvironment CreateSound CreateSoundFilenameWithLabel CreateSoundFromLabel CreateMIDISound SetSoundParamsFromLabel SetSoundDistanceCutoff SetSoundChannel SetSoundVolume SetSoundPitch SetSoundPlayPosition SetSoundDistances SetSoundConeAngles SetSoundConeOrientation
syn keyword jassNative		SetSoundPosition SetSoundVelocity AttachSoundToUnit StartSound StopSound KillSoundWhenDone SetMapMusic ClearMapMusic PlayMusic PlayMusicEx StopMusic ResumeMusic PlayThematicMusic PlayThematicMusicEx EndThematicMusic SetMusicVolume SetMusicPlayPosition SetThematicMusicPlayPosition SetSoundDuration GetSoundDuration GetSoundFileDuration VolumeGroupSetVolume VolumeGroupReset GetSoundIsPlaying GetSoundIsLoading RegisterStackedSound UnregisterStackedSound AddWeatherEffect RemoveWeatherEffect EnableWeatherEffect
syn keyword jassNative		TerrainDeformCrater TerrainDeformRipple TerrainDeformWave TerrainDeformRandom TerrainDeformStop TerrainDeformStopAll AddSpecialEffect AddSpecialEffectLoc AddSpecialEffectTarget DestroyEffect AddSpellEffect AddSpellEffectLoc AddSpellEffectById AddSpellEffectByIdLoc AddSpellEffectTarget AddSpellEffectTargetById AddLightning AddLightningEx DestroyLightning MoveLightning MoveLightningEx GetLightningColorA GetLightningColorR GetLightningColorG GetLightningColorB SetLightningColor GetAbilityEffect GetAbilityEffectById
syn keyword jassNative		GetAbilitySound GetAbilitySoundById GetTerrainCliffLevel SetWaterBaseColor SetWaterDeforms GetTerrainType GetTerrainVariance GetTerrainType GetTerrainVariance SetTerrainType IsTerrainPathable SetTerrainPathable CreateImage DestroyImage ShowImage SetImageConstantHeight SetImagePosition SetImageColor SetImageRender SetImageRenderAlways SetImageAboveWater SetImageType CreateUberSplat DestoryUberSplat ResetUbersplat FinishUbersplat ShowUbersplat SetUbersplatRender SetUbersplatRenderAlways SetBlight SetBlightRect
syn keyword jassNative		SetBlightPoint SetBlightLoc CreateBlightedGoldmine IsPointBlighted SetDoodadAnimation SetDoodadAnimationRect StartMeleeAI StartCampaignAI CommandAI PauseCompAI GetAIDifficulty RemoveGuardPosition RecycleGuardPosition RemoveAllGuardPositions Cheat IsNoVictoryCheat IsNoDefeatCheat Preload PreloadEnd PreloadStart PreloadRefresh PreloadEndEx PreloadGenClear PreloadGenStart PreloadGenEnd Preloader ConvertPlayerColor ConvertPlayerSlotState ConvertVolumeGroup ConvertCameraField ConvertBlendMode ConvertRarityControl
syn keyword jassNative          ConvertTexMapFlags ConvertFogState ConvertEffectType ConvertVersion ConvertItemType ConvertAttackType ConvertDamageType ConvertWeaponType ConvertSoundType ConvertPathingType OrderId OrderId2String UnitId UnitId2String AbilityId AbilityId2String GetObjectName

syn keyword jassBJ		BJDebugMsg RMinBJ RMaxBJ RAbsBJ RSignBJ IMinBJ IMaxBJ IAbsBJ ISignBJ SinBJ CosBJ TanBJ AsinBJ AcosBJ AtanBJ Atan2BJ AngleBetweenPoints DistanceBetweenPoints PolarProjectionBJ GetRandomDirectionDeg GetRandomPercentageBJ GetRandomLocInRect ModuloInteger ModuloReal OffsetLocation OffsetRectBJ RectFromCenterSizeBJ RectContainsCoords RectContainsLoc RectContainsUnit RectContainsItem ConditionalTriggerExecute TriggerExecuteBJ PostTriggerExecuteBJ QueuedTriggerCheck QueuedTriggerGetIndex QueuedTriggerRemoveByIndex
syn keyword jassBJ              QueuedTriggerAttemptExec QueuedTriggerAddBJ QueuedTriggerRemoveBJ QueuedTriggerDoneBJ QueuedTriggerClearBJ QueuedTriggerClearInactiveBJ QueuedTriggerCountBJ IsTriggerQueueEmptyBJ IsTriggerQueuedBJ GetForLoopIndexA SetForLoopIndexA GetForLoopIndexB SetForLoopIndexB PolledWait IntegerTertiaryOpDoNothing CommentString StringIdentity GetBooleanAnd GetBooleanOr PercentToInt PercentTo255 GetTimeOfDay SetTimeOfDay SetTimeOfDayScalePercentBJ GetTimeOfDayScalePercentBJ PlaySound CompareLocationsBJ CompareRectsBJ
syn keyword jassBJ              GetRectFromCircleBJ GetCurrentCameraSetup CameraSetupApplyForPlayer CameraSetupGetFieldSwap SetCameraFieldForPlayer SetCameraTargetControllerNoZForPlayer SetCameraPositionForPlayer SetCameraPositionLocForPlayer RotateCameraAroundLocBJ PanCameraToForPlayer PanCameraToLocForPlayer PanCameraToTimedForPlayer PanCameraToTimedLocForPlayer PanCameraToTimedLocWithZForPlayer SmartCameraPanBJ SetCinematicCameraForPlayer ResetToGameCameraForPlayer CameraSetSourceNoiseForPlayer CameraSetTargetNoiseForPlayer
syn keyword jassBJ              CameraSetEQNoiseForPlayer CameraClearNoiseForPlayer GetCurrentCameraBoundsMapRectBJ GetCameraBoundsMapRect GetPlayableMapRect GetEntireMapRect SetCameraBoundsToRect SetCameraBoundsToRectForPlayerBJ AdjustCameraBoundsBJ AdjustCameraBoundsForPlayerBJ SetCameraQuickPositionForPlayer SetCameraQuickPositionLocForPlayer SetCameraQuickPositionLoc StopCameraForPlayerBJ SetCameraOrientControllerForPlayerBJ CameraSetSmoothingFactorBJ CameraResetSmoothingFactorBJ DisplayTextToForce DisplayTimedTextToForce
syn keyword jassBJ              ClearTextMessagesBJ SubStringBJ GetHandleIdBJ StringHashBJ TriggerRegisterTimerEventPeriodic TriggerRegisterTimerEventSingle TriggerRegisterTimerExpireEventBJ TriggerRegisterPlayerUnitEventSimple TriggerRegisterAnyUnitEventBJ TriggerRegisterPlayerSelectionEventBJ TriggerRegisterPlayerKeyEventBJ TriggerRegisterPlayerEventVictory TriggerRegisterPlayerEventDefeat TriggerRegisterPlayerEventLeave TriggerRegisterPlayerEventAllianceChanged TriggerRegisterPlayerEventEndCinematic TriggerRegisterGameStateEventTimeOfDay
syn keyword jassBj              TriggerRegisterEnterRegionSimple TriggerRegisterLeaveRegionSimple TriggerRegisterEnterRectSimple TriggerRegisterLeaveRectSimple TriggerRegisterDistanceBetweenUnits TriggerRegisterUnitInRangeSimple TriggerRegisterUnitLifeEvent TriggerRegisterUnitManaEvent TriggerRegisterDialogEventBJ TriggerRegisterShowSkillEventBJ TriggerRegisterBuildSubmenuEventBJ TriggerRegisterGameLoadedEventBJ TriggerRegisterGameSavedEventBJ RegisterDestDeathInRegionEnum TriggerRegisterDestDeathInRegionEvent AddWeatherEffectSaveLast
syn keyword jassBJ              GetLastCreatedWeatherEffect RemoveWeatherEffectBJ TerrainDeformationCraterBJ TerrainDeformationRippleBJ TerrainDeformationWaveBJ TerrainDeformationRandomBJ TerrainDeformationStopBJ GetLastCreatedTerrainDeformation AddLightningLoc DestroyLightningBJ MoveLightningLoc GetLightningColorABJ GetLightningColorRBJ GetLightningColorGBJ GetLightningColorBBJ SetLightningColorBJ GetLastCreatedLightningBJ GetAbilityEffectBJ GetAbilitySoundBJ GetTerrainCliffLevelBJ GetTerrainTypeBJ GetTerrainVarianceBJ SetTerrainTypeBJ
syn keyword jassBJ              IsTerrainPathableBJ SetTerrainPathableBJ SetWaterBaseColorBJ CreateFogModifierRectSimple CreateFogModifierRadiusLocSimple CreateFogModifierRectBJ CreateFogModifierRadiusLocBJ GetLastCreatedFogModifier FogEnableOn FogEnableOff FogMaskEnableOn FogMaskEnableOff UseTimeOfDayBJ SetTerrainFogExBJ ResetTerrainFogBJ SetDoodadAnimationBJ SetDoodadAnimationRectBJ AddUnitAnimationPropertiesBJ CreateImageBJ ShowImageBJ SetImagePositionBJ SetImageColorBJ GetLastCreatedImage CreateUbersplatBJ ShowUbersplatBJ
syn keyword jassBJ              GetLastCreatedUbersplat PlaySoundBJ StopSoundBJ SetSoundVolumeBJ SetSoundOffsetBJ SetSoundDistanceCutoffBJ SetSoundPitchBJ SetSoundPositionLocBJ AttachSoundToUnitBJ SetSoundConeAnglesBJ KillSoundWhenDoneBJ PlaySoundAtPointBJ PlaySoundOnUnitBJ PlaySoundFromOffsetBJ PlayMusicBJ PlayMusicExBJ SetMusicOffsetBJ PlayThematicMusicBJ PlayThematicMusicExBJ SetThematicMusicOffsetBJ EndThematicMusicBJ StopMusicBJ ResumeMusicBJ SetMusicVolumeBJ GetSoundDurationBJ GetSoundFileDurationBJ GetLastPlayedSound GetLastPlayedMusic
syn keyword jassBJ              VolumeGroupSetVolumeBJ SetCineModeVolumeGroupsImmediateBJ SetCineModeVolumeGroupsBJ SetSpeechVolumeGroupsImmediateBJ SetSpeechVolumeGroupsBJ VolumeGroupResetImmediateBJ VolumeGroupResetBJ GetSoundIsPlayingBJ WaitForSoundBJ SetMapMusicIndexedBJ SetMapMusicRandomBJ ClearMapMusicBJ SetStackedSoundBJ StartSoundForPlayerBJ VolumeGroupSetVolumeForPlayerBJ EnableDawnDusk IsDawnDuskEnabled SetAmbientDaySound SetAmbientNightSound AddSpecialEffectLocBJ AddSpecialEffectTargetUnitBJ DestroyEffectBJ GetLastCreatedEffectBJ
syn keyword jassBJ              GetItemLoc GetItemLifeBJ SetItemLifeBJ AddHeroXPSwapped SetHeroLevelBJ DecUnitAbilityLevelSwapped IncUnitAbilityLevelSwapped SetUnitAbilityLevelSwapped GetUnitAbilityLevelSwapped UnitHasBuffBJ UnitRemoveBuffBJ UnitAddItemSwapped UnitAddItemByIdSwapped UnitRemoveItemSwapped UnitRemoveItemFromSlotSwapped CreateItemLoc GetLastCreatedItem GetLastRemovedItem SetItemPositionLoc GetLearnedSkillBJ SuspendHeroXPBJ SetPlayerHandicapXPBJ GetPlayerHandicapXPBJ SetPlayerHandicapBJ GetPlayerHandicapBJ GetHeroStatBJ SetHeroStat
syn keyword jassBJ              ModifyHeroStat ModifyHeroSkillPoints UnitDropItemPointBJ UnitDropItemPointLoc UnitDropItemSlotBJ UnitDropItemTargetBJ UnitUseItemDestructable UnitUseItemPointLoc UnitItemInSlotBJ GetInventoryIndexOfItemTypeBJ GetItemOfTypeFromUnitBJ UnitHasItemOfTypeBJ UnitInventoryCount UnitInventorySizeBJ SetItemInvulnerableBJ SetItemDropOnDeathBJ SetItemDroppableBJ SetItemPlayerBJ SetItemVisibleBJ IsItemHiddenBJ ChooseRandomItemBJ ChooseRandomItemExBJ ChooseRandomNPBuildingBJ ChooseRandomCreepBJ EnumItemsInRectBJ RandomItemInRectBJEnum
syn keyword jassBJ              RandomItemInRectBJ RandomItemInRectSimpleBJ CheckItemStatus CheckItemcodeStatus UnitId2OrderIdBJ String2UnitIdBJ UnitId2StringBJ String2OrderIdBJ OrderId2StringBJ GetIssuedOrderIdBJ GetKillingUnitBJ CreateUnitAtLocSaveLast GetLastCreatedUnit CreateNUnitsAtLoc CreateNUnitsAtLocFacingLocBJ GetLastCreatedGroupEnum GetLastCreatedGroup CreateCorpseLocBJ UnitSuspendDecayBJ DelayedSuspendDecayStopAnimEnum DelayedSuspendDecayBoneEnum DelayedSuspendDecayFleshEnum DelayedSuspendDecay DelayedSuspendDecayCreate CreatePermanentCorpseLocBJ
syn keyword jassBJ              GetUnitStateSwap GetUnitStatePercent GetUnitLifePercent GetUnitManaPercent SelectUnitSingle SelectGroupBJEnum SelectGroupBJ SelectUnitAdd SelectUnitRemove ClearSelectionForPlayer SelectUnitForPlayerSingle SelectGroupForPlayerBJ SelectUnitAddForPlayer SelectUnitRemoveForPlayer SetUnitLifeBJ SetUnitManaBJ SetUnitLifePercentBJ SetUnitManaPercentBJ IsUnitDeadBJ IsUnitAliveBJ IsUnitGroupDeadBJEnum IsUnitGroupDeadBJ IsUnitGroupEmptyBJEnum IsUnitGroupEmptyBJ IsUnitGroupInRectBJEnum IsUnitGroupInRectBJ IsUnitHiddenBJ ShowUnitHide
syn keyword jassBJ              ShowUnitShow IssueHauntOrderAtLocBJFilter IssueHauntOrderAtLocBJ IssueBuildOrderByIdLocBJ IssueTrainOrderByIdBJ GroupTrainOrderByIdBJ IssueUpgradeOrderByIdBJ GetAttackedUnitBJ SetUnitFlyHeightBJ SetUnitTurnSpeedBJ SetUnitPropWindowBJ GetUnitPropWindowBJ GetUnitDefaultPropWindowBJ SetUnitBlendTimeBJ SetUnitAcquireRangeBJ UnitSetCanSleepBJ UnitCanSleepBJ UnitWakeUpBJ UnitIsSleepingBJ WakePlayerUnitsEnum WakePlayerUnits EnableCreepSleepBJ UnitGenerateAlarms DoesUnitGenerateAlarms PauseAllUnitsBJEnum PauseAllUnitsBJ PauseUnitBJ
syn keyword jassBJ              IsUnitPausedBJ UnitPauseTimedLifeBJ UnitApplyTimedLifeBJ UnitShareVisionBJ UnitRemoveBuffsBJ UnitRemoveBuffsExBJ UnitCountBuffsExBJ UnitRemoveAbilityBJ UnitAddAbilityBJ UnitRemoveTypeBJ UnitAddTypeBJ UnitMakeAbilityPermanentBJ SetUnitExplodedBJ ExplodeUnitBJ GetTransportUnitBJ GetLoadedUnitBJ IsUnitInTransportBJ IsUnitLoadedBJ IsUnitIllusionBJ ReplaceUnitBJ GetLastReplacedUnitBJ SetUnitPositionLocFacingBJ SetUnitPositionLocFacingLocBJ AddItemToStockBJ AddUnitToStockBJ RemoveItemFromStockBJ RemoveUnitFromStockBJ SetUnitUseFoodBJ
syn keyword jassBJ              UnitDamagePointLoc UnitDamageTargetBJ CreateDestructableLoc CreateDeadDestructableLocBJ GetLastCreatedDestructable ShowDestructableBJ SetDestructableInvulnerableBJ IsDestructableInvulnerableBJ GetDestructableLoc EnumDestructablesInRectAll EnumDestructablesInCircleBJFilter IsDestructableDeadBJ IsDestructableAliveBJ RandomDestructableInRectBJEnum RandomDestructableInRectBJ RandomDestructableInRectSimpleBJ EnumDestructablesInCircleBJ SetDestructableLifePercentBJ SetDestructableMaxLifeBJ ModifyGateBJ GetElevatorHeight
syn keyword jassBJ              ChangeElevatorHeight NudgeUnitsInRectEnum NudgeItemsInRectEnum NudgeObjectsInRect NearbyElevatorExistsEnum NearbyElevatorExists FindElevatorWallBlockerEnum ChangeElevatorWallBlocker ChangeElevatorWalls WaygateActivateBJ WaygateIsActiveBJ WaygateSetDestinationLocBJ WaygateGetDestinationLocBJ UnitSetUsesAltIconBJ ForceUIKeyBJ ForceUICancelBJ ForGroupBJ GroupAddUnitSimple GroupRemoveUnitSimple GroupAddGroupEnum GroupAddGroup GroupRemoveGroupEnum GroupRemoveGroup ForceAddPlayerSimple ForceRemovePlayerSimple
syn keyword jassBJ              GroupPickRandomUnitEnum GroupPickRandomUnit ForcePickRandomPlayerEnum ForcePickRandomPlayer EnumUnitsSelected GetUnitsInRectMatching GetUnitsInRectAll GetUnitsInRectOfPlayerFilter GetUnitsInRectOfPlayer GetUnitsInRangeOfLocMatching GetUnitsInRangeOfLocAll GetUnitsOfTypeIdAllFilter GetUnitsOfTypeIdAll GetUnitsOfPlayerMatching GetUnitsOfPlayerAll GetUnitsOfPlayerAndTypeIdFilter GetUnitsOfPlayerAndTypeId GetUnitsSelectedAll GetForceOfPlayer GetPlayersAll GetPlayersByMapControl GetPlayersAllies GetPlayersEnemies
syn keyword jassBJ              GetPlayersMatching CountUnitsInGroupEnum CountUnitsInGroup CountPlayersInForceEnum CountPlayersInForceBJ GetRandomSubGroupEnum GetRandomSubGroup LivingPlayerUnitsOfTypeIdFilter CountLivingPlayerUnitsOfTypeId ResetUnitAnimation SetUnitTimeScalePercent SetUnitScalePercent SetUnitVertexColorBJ UnitAddIndicatorBJ DestructableAddIndicatorBJ ItemAddIndicatorBJ SetUnitFacingToFaceLocTimed SetUnitFacingToFaceUnitTimed QueueUnitAnimationBJ SetDestructableAnimationBJ QueueDestructableAnimationBJ SetDestAnimationSpeedPercent
syn keyword jassBJ              DialogDisplayBJ DialogSetMessageBJ DialogAddButtonBJ DialogAddButtonWithHotkeyBJ DialogClearBJ GetLastCreatedButtonBJ GetClickedButtonBJ GetClickedDialogBJ SetPlayerAllianceBJ SetPlayerAllianceStateAllyBJ SetPlayerAllianceStateVisionBJ SetPlayerAllianceStateControlBJ SetPlayerAllianceStateFullControlBJ SetPlayerAllianceStateBJ SetForceAllianceStateBJ PlayersAreCoAllied ShareEverythingWithTeamAI ShareEverythingWithTeam ConfigureNeutralVictim MakeUnitsPassiveForPlayerEnum MakeUnitsPassiveForPlayer MakeUnitsPassiveForTeam
syn keyword jassBJ              AllowVictoryDefeat EndGameBJ MeleeVictoryDialogBJ MeleeDefeatDialogBJ GameOverDialogBJ RemovePlayerPreserveUnitsBJ CustomVictoryOkBJ CustomVictoryQuitBJ CustomVictoryDialogBJ CustomVictorySkipBJ CustomVictoryBJ CustomDefeatRestartBJ CustomDefeatReduceDifficultyBJ CustomDefeatLoadBJ CustomDefeatQuitBJ CustomDefeatDialogBJ CustomDefeatBJ SetNextLevelBJ SetPlayerOnScoreScreenBJ CreateQuestBJ DestroyQuestBJ QuestSetEnabledBJ QuestSetTitleBJ QuestSetDescriptionBJ QuestSetCompletedBJ QuestSetFailedBJ QuestSetDiscoveredBJ
syn keyword jassBJ              GetLastCreatedQuestBJ CreateQuestItemBJ QuestItemSetDescriptionBJ QuestItemSetCompletedBJ GetLastCreatedQuestItemBJ CreateDefeatConditionBJ DestroyDefeatConditionBJ DefeatConditionSetDescriptionBJ GetLastCreatedDefeatConditionBJ FlashQuestDialogButtonBJ QuestMessageBJ StartTimerBJ CreateTimerBJ DestroyTimerBJ PauseTimerBJ GetLastCreatedTimerBJ CreateTimerDialogBJ DestroyTimerDialogBJ TimerDialogSetTitleBJ TimerDialogSetTitleColorBJ TimerDialogSetTimeColorBJ TimerDialogSetSpeedBJ TimerDialogDisplayForPlayerBJ
syn keyword jassBJ              TimerDialogDisplayBJ GetLastCreatedTimerDialogBJ LeaderboardResizeBJ LeaderboardSetPlayerItemValueBJ LeaderboardSetPlayerItemLabelBJ LeaderboardSetPlayerItemStyleBJ LeaderboardSetPlayerItemLabelColorBJ LeaderboardSetPlayerItemValueColorBJ LeaderboardSetLabelColorBJ LeaderboardSetValueColorBJ LeaderboardSetLabelBJ LeaderboardSetStyleBJ LeaderboardGetItemCountBJ LeaderboardHasPlayerItemBJ ForceSetLeaderboardBJ CreateLeaderboardBJ DestroyLeaderboardBJ LeaderboardDisplayBJ LeaderboardAddItemBJ LeaderboardRemovePlayerItemBJ
syn keyword jassBJ              LeaderboardSortItemsBJ LeaderboardSortItemsByPlayerBJ LeaderboardSortItemsByLabelBJ LeaderboardGetPlayerIndexBJ LeaderboardGetIndexedPlayerBJ PlayerGetLeaderboardBJ GetLastCreatedLeaderboard CreateMultiboardBJ DestroyMultiboardBJ GetLastCreatedMultiboard MultiboardDisplayBJ MultiboardMinimizeBJ MultiboardSetTitleTextColorBJ MultiboardAllowDisplayBJ MultiboardSetItemStyleBJ MultiboardSetItemValueBJ MultiboardSetItemColorBJ MultiboardSetItemWidthBJ MultiboardSetItemIconBJ TextTagSize2Height TextTagSpeed2Velocity
syn keyword jassBJ              SetTextTagColorBJ SetTextTagVelocityBJ SetTextTagTextBJ SetTextTagPosBJ SetTextTagPosUnitBJ SetTextTagSuspendedBJ SetTextTagPermanentBJ SetTextTagAgeBJ SetTextTagLifespanBJ SetTextTagFadepointBJ CreateTextTagLocBJ CreateTextTagUnitBJ DestroyTextTagBJ ShowTextTagForceBJ GetLastCreatedTextTag PauseGameOn PauseGameOff SetUserControlForceOn SetUserControlForceOff ShowInterfaceForceOn ShowInterfaceForceOff PingMinimapForForce PingMinimapLocForForce PingMinimapForPlayer PingMinimapLocForPlayer PingMinimapForForceEx
syn keyword jassBJ              PingMinimapLocForForceEx EnableWorldFogBoundaryBJ EnableOcclusionBJ CancelCineSceneBJ TryInitCinematicBehaviorBJ SetCinematicSceneBJ GetTransmissionDuration WaitTransmissionDuration DoTransmissionBasicsXYBJ TransmissionFromUnitWithNameBJ TransmissionFromUnitTypeWithNameBJ GetLastTransmissionDurationBJ ForceCinematicSubtitlesBJ CinematicModeExBJ CinematicModeBJ DisplayCineFilterBJ CinematicFadeCommonBJ FinishCinematicFadeBJ FinishCinematicFadeAfterBJ ContinueCinematicFadeBJ ContinueCinematicFadeAfterBJ
syn keyword jassBJ              AbortCinematicFadeBJ CinematicFadeBJ CinematicFilterGenericBJ RescueUnitBJ TriggerActionUnitRescuedBJ TryInitRescuableTriggersBJ SetRescueUnitColorChangeBJ SetRescueBuildingColorChangeBJ MakeUnitRescuableToForceBJEnum MakeUnitRescuableToForceBJ InitRescuableBehaviorBJ SetPlayerTechResearchedSwap SetPlayerTechMaxAllowedSwap SetPlayerMaxHeroesAllowed GetPlayerTechCountSimple GetPlayerTechMaxAllowedSwap SetPlayerAbilityAvailableBJ SetCampaignMenuRaceBJ SetMissionAvailableBJ SetCampaignAvailableBJ SetCinematicAvailableBJ
syn keyword jassBJ              InitGameCacheBJ SaveGameCacheBJ GetLastCreatedGameCacheBJ InitHashtableBJ GetLastCreatedHashtableBJ StoreRealBJ StoreIntegerBJ StoreBooleanBJ StoreStringBJ StoreUnitBJ SaveRealBJ SaveIntegerBJ SaveBooleanBJ SaveStringBJ SavePlayerHandleBJ SaveWidgetHandleBJ SaveDestructableHandleBJ SaveItemHandleBJ SaveUnitHandleBJ SaveAbilityHandleBJ SaveTimerHandleBJ SaveTriggerHandleBJ SaveTriggerConditionHandleBJ SaveTriggerActionHandleBJ SaveTriggerEventHandleBJ SaveForceHandleBJ SaveGroupHandleBJ SaveLocationHandleBJ SaveRectHandleBJ
syn keyword jassBJ              SaveBooleanExprHandleBJ SaveSoundHandleBJ SaveEffectHandleBJ SaveUnitPoolHandleBJ SaveItemPoolHandleBJ SaveQuestHandleBJ SaveQuestItemHandleBJ SaveDefeatConditionHandleBJ SaveTimerDialogHandleBJ SaveLeaderboardHandleBJ SaveMultiboardHandleBJ SaveMultiboardItemHandleBJ SaveTrackableHandleBJ SaveDialogHandleBJ SaveButtonHandleBJ SaveTextTagHandleBJ SaveLightningHandleBJ SaveImageHandleBJ SaveUbersplatHandleBJ SaveRegionHandleBJ SaveFogStateHandleBJ SaveFogModifierHandleBJ SaveAgentHandleBJ SaveHashtableHandleBJ GetStoredRealBJ
syn keyword jassBJ              GetStoredIntegerBJ GetStoredBooleanBJ GetStoredStringBJ LoadRealBJ LoadIntegerBJ LoadBooleanBJ LoadStringBJ LoadPlayerHandleBJ LoadWidgetHandleBJ LoadDestructableHandleBJ LoadItemHandleBJ LoadUnitHandleBJ LoadAbilityHandleBJ LoadTimerHandleBJ LoadTriggerHandleBJ LoadTriggerConditionHandleBJ LoadTriggerActionHandleBJ LoadTriggerEventHandleBJ LoadForceHandleBJ LoadGroupHandleBJ LoadLocationHandleBJ LoadRectHandleBJ LoadBooleanExprHandleBJ LoadSoundHandleBJ LoadEffectHandleBJ LoadUnitPoolHandleBJ LoadItemPoolHandleBJ LoadQuestHandleBJ
syn keyword jassBJ              LoadQuestItemHandleBJ LoadDefeatConditionHandleBJ LoadTimerDialogHandleBJ LoadLeaderboardHandleBJ LoadMultiboardHandleBJ LoadMultiboardItemHandleBJ LoadTrackableHandleBJ LoadDialogHandleBJ LoadButtonHandleBJ LoadTextTagHandleBJ LoadLightningHandleBJ LoadImageHandleBJ LoadUbersplatHandleBJ LoadRegionHandleBJ LoadFogStateHandleBJ LoadFogModifierHandleBJ LoadHashtableHandleBJ RestoreUnitLocFacingAngleBJ RestoreUnitLocFacingPointBJ GetLastRestoredUnitBJ FlushGameCacheBJ FlushStoredMissionBJ FlushParentHashtableBJ FlushChildHashtableBJ
syn keyword jassBJ              HaveStoredValue HaveSavedValue ShowCustomCampaignButton IsCustomCampaignButtonVisibile LoadGameBJ SaveAndChangeLevelBJ SaveAndLoadGameBJ RenameSaveDirectoryBJ RemoveSaveDirectoryBJ CopySaveGameBJ GetPlayerStartLocationX GetPlayerStartLocationY GetPlayerStartLocationLoc GetRectCenter IsPlayerSlotState GetFadeFromSeconds AdjustPlayerStateSimpleBJ AdjustPlayerStateBJ SetPlayerStateBJ SetPlayerFlagBJ SetPlayerTaxRateBJ GetPlayerTaxRateBJ IsPlayerFlagSetBJ AddResourceAmountBJ GetConvertedPlayerId ConvertedPlayer GetRectWidthBJ
syn keyword jassBJ              GetRectHeightBJ BlightGoldMineForPlayerBJ BlightGoldMineForPlayer GetLastHauntedGoldMine IsPointBlightedBJ SetPlayerColorBJEnum SetPlayerColorBJ SetPlayerUnitAvailableBJ LockGameSpeedBJ UnlockGameSpeedBJ IssueTargetOrderBJ IssuePointOrderLocBJ IssueTargetDestructableOrder IssueTargetItemOrder IssueImmediateOrderBJ GroupTargetOrderBJ GroupPointOrderLocBJ GroupImmediateOrderBJ GroupTargetDestructableOrder GroupTargetItemOrder GetDyingDestructable SetUnitRallyPoint SetUnitRallyUnit SetUnitRallyDestructable SaveDyingWidget
syn keyword jassBJ              SetBlightRectBJ SetBlightRadiusLocBJ GetAbilityName MeleeStartingVisibility MeleeStartingResources ReducePlayerTechMaxAllowed MeleeStartingHeroLimit MeleeTrainedUnitIsHeroBJFilter MeleeGrantItemsToHero MeleeGrantItemsToTrainedHero MeleeGrantItemsToHiredHero MeleeGrantHeroItems MeleeClearExcessUnit MeleeClearNearbyUnits MeleeClearExcessUnits MeleeEnumFindNearestMine MeleeFindNearestMine MeleeRandomHeroLoc MeleeGetProjectedLoc MeleeGetNearestValueWithin MeleeGetLocWithinRect MeleeStartingUnitsHuman MeleeStartingUnitsOrc
syn keyword jassBJ              MeleeStartingUnitsUndead MeleeStartingUnitsNightElf MeleeStartingUnitsUnknownRace MeleeStartingUnits MeleeStartingUnitsForPlayer PickMeleeAI MeleeStartingAI LockGuardPosition MeleePlayerIsOpponent MeleeGetAllyStructureCount MeleeGetAllyCount MeleeGetAllyKeyStructureCount MeleeDoDrawEnum MeleeDoVictoryEnum MeleeDoDefeat MeleeDoDefeatEnum MeleeDoLeave MeleeRemoveObservers MeleeCheckForVictors MeleeCheckForLosersAndVictors MeleeGetCrippledWarningMessage MeleeGetCrippledTimerMessage MeleeGetCrippledRevealedMessage
syn keyword jassBJ              MeleeExposePlayer MeleeExposeAllPlayers MeleeCrippledPlayerTimeout MeleePlayerIsCrippled MeleeCheckForCrippledPlayers MeleeCheckLostUnit MeleeCheckAddedUnit MeleeTriggerActionConstructCancel MeleeTriggerActionUnitDeath MeleeTriggerActionUnitConstructionStart MeleeTriggerActionPlayerDefeated MeleeTriggerActionPlayerLeft MeleeTriggerActionAllianceChange MeleeTriggerTournamentFinishSoon MeleeWasUserPlayer MeleeTournamentFinishNowRuleA MeleeTriggerTournamentFinishNow MeleeInitVictoryDefeat CheckInitPlayerSlotAvailability
syn keyword jassBJ              SetPlayerSlotAvailable TeamInitPlayerSlots MeleeInitPlayerSlots FFAInitPlayerSlots OneOnOneInitPlayerSlots InitGenericPlayerSlots SetDNCSoundsDawn SetDNCSoundsDusk SetDNCSoundsDay SetDNCSoundsNight InitDNCSounds InitBlizzardGlobals InitQueuedTriggers InitMapRects InitSummonableCaps UpdateStockAvailability UpdateEachStockBuildingEnum UpdateEachStockBuilding PerformStockUpdates StartStockUpdates RemovePurchasedItem InitNeutralBuildings MarkGameStarted DetectGameStarted InitBlizzard RandomDistReset RandomDistAddItem RandomDistChoose UnitDropItem WidgetDropItem

syn keyword jassConstant	FALSE TRUE JASS_MAX_ARRAY_SIZE DAMAGE_TYPE_FORCE DAMAGE_TYPE_DEATH DAMAGE_TYPE_MIND DAMAGE_TYPE_PLANT DAMAGE_TYPE_DEFENSIVE DAMAGE_TYPE_DEMOLITION DAMAGE_TYPE_SLOW_POISON DAMAGE_TYPE_SPIRIT_LINK DAMAGE_TYPE_SHADOW_STRIKE DAMAGE_TYPE_UNIVERSAL WEAPON_TYPE_WHOKNOWS WEAPON_TYPE_METAL_LIGHT_CHOP WEAPON_TYPE_METAL_MEDIUM_CHOP WEAPON_TYPE_METAL_HEAVY_CHOP WEAPON_TYPE_METAL_LIGHT_SLICE WEAPON_TYPE_METAL_MEDIUM_SLICE WEAPON_TYPE_METAL_HEAVY_SLICE WEAPON_TYPE_METAL_MEDIUM_BASH WEAPON_TYPE_METAL_HEAVY_BASH
syn keyword jassConstant        WEAPON_TYPE_METAL_MEDIUM_STAB WEAPON_TYPE_METAL_HEAVY_STAB WEAPON_TYPE_WOOD_LIGHT_SLICE WEAPON_TYPE_WOOD_MEDIUM_SLICE WEAPON_TYPE_WOOD_HEAVY_SLICE WEAPON_TYPE_WOOD_LIGHT_BASH WEAPON_TYPE_WOOD_MEDIUM_BASH WEAPON_TYPE_WOOD_HEAVY_BASH WEAPON_TYPE_WOOD_LIGHT_STAB WEAPON_TYPE_WOOD_MEDIUM_STAB WEAPON_TYPE_CLAW_LIGHT_SLICE WEAPON_TYPE_CLAW_MEDIUM_SLICE WEAPON_TYPE_CLAW_HEAVY_SLICE WEAPON_TYPE_AXE_MEDIUM_CHOP WEAPON_TYPE_ROCK_HEAVY_BASH  PATHING_TYPE_ANY PATHING_TYPE_WALKABILITY PATHING_TYPE_FLYABILITY
syn keyword jassConstant        PATHING_TYPE_BUILDABILITY PATHING_TYPE_PEONHARVESTPATHING PATHING_TYPE_BLIGHTPATHING PATHING_TYPE_FLOATABILITY PATHING_TYPE_AMPHIBIOUSPATHING RACE_PREF_HUMAN RACE_PREF_ORC RACE_PREF_NIGHTELF RACE_PREF_UNDEAD RACE_PREF_DEMON RACE_PREF_RANDOM RACE_PREF_USER_SELECTABLE MAP_CONTROL_USER MAP_CONTROL_COMPUTER MAP_CONTROL_RESCUABLE MAP_CONTROL_NEUTRAL MAP_CONTROL_CREEP MAP_CONTROL_NONE  GAME_TYPE_MELEE GAME_TYPE_FFA GAME_TYPE_USE_MAP_SETTINGS GAME_TYPE_BLIZ GAME_TYPE_ONE_ON_ONE GAME_TYPE_TWO_TEAM_PLAY
syn keyword jassConstant        GAME_TYPE_THREE_TEAM_PLAY GAME_TYPE_FOUR_TEAM_PLAY MAP_FOG_HIDE_TERRAIN MAP_FOG_MAP_EXPLORED MAP_FOG_ALWAYS_VISIBLE MAP_USE_HANDICAPS MAP_OBSERVERS MAP_OBSERVERS_ON_DEATH MAP_FIXED_COLORS MAP_LOCK_RESOURCE_TRADING MAP_RESOURCE_TRADING_ALLIES_ONLY MAP_LOCK_ALLIANCE_CHANGES MAP_ALLIANCE_CHANGES_HIDDEN  MAP_CHEATS MAP_CHEATS_HIDDEN MAP_LOCK_SPEED MAP_LOCK_RANDOM_SEED MAP_SHARED_ADVANCED_CONTROL MAP_RANDOM_HERO MAP_RANDOM_RACES MAP_RELOADED  MAP_PLACEMENT_RANDOM MAP_PLACEMENT_FIXED
syn keyword jassConstant	MAP_PLACEMENT_USE_MAP_SETTINGS MAP_PLACEMENT_TEAMS_TOGETHER MAP_LOC_PRIO_LOW MAP_LOC_PRIO_HIGH MAP_LOC_PRIO_NOT MAP_DENSITY_NONE MAP_DENSITY_LIGHT MAP_DENSITY_MEDIUM MAP_DENSITY_HEAVY MAP_DIFFICULTY_EASY MAP_DIFFICULTY_NORMAL MAP_DIFFICULTY_HARD MAP_DIFFICULTY_INSANE MAP_SPEED_SLOWEST MAP_SPEED_SLOW MAP_SPEED_NORMAL MAP_SPEED_FAST MAP_SPEED_FASTEST PLAYER_SLOT_STATE_EMPTY PLAYER_SLOT_STATE_PLAYING PLAYER_SLOT_STATE_LEFT SOUND_VOLUMEGROUP_UNITMOVEMENT SOUND_VOLUMEGROUP_UNITSOUNDS
syn keyword jassConstant	SOUND_VOLUMEGROUP_COMBAT SOUND_VOLUMEGROUP_SPELLS SOUND_VOLUMEGROUP_UI SOUND_VOLUMEGROUP_MUSIC SOUND_VOLUMEGROUP_AMBIENTSOUNDS SOUND_VOLUMEGROUP_FIRE GAME_STATE_DIVINE_INTERVENTION GAME_STATE_DISCONNECTED GAME_STATE_TIME_OF_DAY PLAYER_STATE_GAME_RESULT PLAYER_STATE_RESOURCE_GOLD PLAYER_STATE_RESOURCE_LUMBER PLAYER_STATE_RESOURCE_HERO_TOKENS PLAYER_STATE_RESOURCE_FOOD_CAP PLAYER_STATE_RESOURCE_FOOD_USED PLAYER_STATE_FOOD_CAP_CEILING PLAYER_STATE_GIVES_BOUNTY
syn keyword jassConstant	PLAYER_STATE_ALLIED_VICTORY PLAYER_STATE_PLACED PLAYER_STATE_OBSERVER_ON_DEATH PLAYER_STATE_OBSERVER PLAYER_STATE_UNFOLLOWABLE PLAYER_STATE_GOLD_UPKEEP_RATE PLAYER_STATE_LUMBER_UPKEEP_RATE PLAYER_STATE_GOLD_GATHERED PLAYER_STATE_LUMBER_GATHERED PLAYER_STATE_NO_CREEP_SLEEP UNIT_STATE_LIFE UNIT_STATE_MAX_LIFE UNIT_STATE_MANA UNIT_STATE_MAX_MANA AI_DIFFICULTY_NEWBIE AI_DIFFICULTY_NORMAL AI_DIFFICULTY_INSANE PLAYER_SCORE_UNITS_TRAINED PLAYER_SCORE_UNITS_KILLED PLAYER_SCORE_STRUCT_BUILT
syn keyword jassConstant	PLAYER_SCORE_STRUCT_RAZED PLAYER_SCORE_TECH_PERCENT PLAYER_SCORE_FOOD_MAXPROD PLAYER_SCORE_FOOD_MAXUSED PLAYER_SCORE_HEROES_KILLED PLAYER_SCORE_ITEMS_GAINED PLAYER_SCORE_MERCS_HIRED PLAYER_SCORE_GOLD_MINED_TOTAL PLAYER_SCORE_GOLD_MINED_UPKEEP PLAYER_SCORE_GOLD_LOST_UPKEEP PLAYER_SCORE_GOLD_LOST_TAX PLAYER_SCORE_GOLD_GIVEN PLAYER_SCORE_GOLD_RECEIVED PLAYER_SCORE_LUMBER_TOTAL PLAYER_SCORE_LUMBER_LOST_UPKEEP PLAYER_SCORE_LUMBER_LOST_TAX PLAYER_SCORE_LUMBER_GIVEN PLAYER_SCORE_LUMBER_RECEIVED
syn keyword jassConstant	PLAYER_SCORE_UNIT_TOTAL PLAYER_SCORE_HERO_TOTAL PLAYER_SCORE_RESOURCE_TOTAL PLAYER_SCORE_TOTAL EVENT_GAME_VICTORY EVENT_GAME_END_LEVEL EVENT_GAME_VARIABLE_LIMIT EVENT_GAME_STATE_LIMIT EVENT_GAME_TIMER_EXPIRED EVENT_GAME_ENTER_REGION EVENT_GAME_LEAVE_REGION EVENT_GAME_TRACKABLE_HIT EVENT_GAME_TRACKABLE_TRACK EVENT_GAME_SHOW_SKILL EVENT_GAME_BUILD_SUBMENU EVENT_PLAYER_STATE_LIMIT EVENT_UNIT_DEATH EVENT_UNIT_DECAY
syn keyword jassConstant	EVENT_UNIT_DETECTED EVENT_UNIT_HIDDEN EVENT_UNIT_SELECTED EVENT_UNIT_DESELECTED EVENT_UNIT_STATE_LIMIT EVENT_UNIT_ACQUIRED_TARGET EVENT_UNIT_TARGET_IN_RANGE EVENT_UNIT_ATTACKED EVENT_UNIT_RESCUED  EVENT_UNIT_CONSTRUCT_CANCEL EVENT_UNIT_CONSTRUCT_FINISH EVENT_UNIT_UPGRADE_START EVENT_UNIT_UPGRADE_CANCEL EVENT_UNIT_UPGRADE_FINISH EVENT_UNIT_TRAIN_START EVENT_UNIT_TRAIN_CANCEL EVENT_UNIT_TRAIN_FINISH  EVENT_UNIT_RESEARCH_START EVENT_UNIT_RESEARCH_CANCEL EVENT_UNIT_RESEARCH_FINISH
syn keyword jassConstant	EVENT_UNIT_ISSUED_ORDER EVENT_UNIT_ISSUED_POINT_ORDER EVENT_UNIT_ISSUED_TARGET_ORDER EVENT_PLAYER_UNIT_ISSUED_UNIT_ORDER EVENT_UNIT_HERO_LEVEL EVENT_UNIT_HERO_SKILL EVENT_UNIT_HERO_REVIVABLE EVENT_UNIT_HERO_REVIVE_START EVENT_UNIT_HERO_REVIVE_CANCEL EVENT_UNIT_HERO_REVIVE_FINISH EVENT_UNIT_SUMMON EVENT_UNIT_DROP_ITEM EVENT_UNIT_PICKUP_ITEM EVENT_UNIT_USE_ITEM  EVENT_UNIT_LOADED  EVENT_WIDGET_DEATH EVENT_DIALOG_BUTTON_CLICK EVENT_DIALOG_CLICK EVENT_GAME_LOADED EVENT_GAME_TOURNAMENT_FINISH_SOON EVENT_GAME_TOURNAMENT_FINISH_NOW EVENT_GAME_SAVE
syn keyword jassConstant	EVENT_PLAYER_ARROW_LEFT_DOWN EVENT_PLAYER_ARROW_LEFT_UP EVENT_PLAYER_ARROW_RIGHT_DOWN EVENT_PLAYER_ARROW_RIGHT_UP EVENT_PLAYER_ARROW_DOWN_DOWN EVENT_PLAYER_ARROW_DOWN_UP EVENT_PLAYER_ARROW_UP_DOWN EVENT_PLAYER_ARROW_UP_UP EVENT_PLAYER_UNIT_SELL EVENT_PLAYER_UNIT_CHANGE_OWNER EVENT_PLAYER_UNIT_SELL_ITEM EVENT_PLAYER_UNIT_SPELL_CHANNEL EVENT_PLAYER_UNIT_SPELL_CAST EVENT_PLAYER_UNIT_SPELL_EFFECT EVENT_PLAYER_UNIT_SPELL_FINISH EVENT_PLAYER_UNIT_SPELL_ENDCAST EVENT_PLAYER_UNIT_PAWN_ITEM
syn keyword jassConstant	EVENT_UNIT_SELL EVENT_UNIT_CHANGE_OWNER EVENT_UNIT_SELL_ITEM EVENT_UNIT_SPELL_CHANNEL EVENT_UNIT_SPELL_CAST EVENT_UNIT_SPELL_EFFECT EVENT_UNIT_SPELL_FINISH EVENT_UNIT_SPELL_ENDCAST EVENT_UNIT_PAWN_ITEM LESS_THAN LESS_THAN_OR_EQUAL EQUAL GREATER_THAN_OR_EQUAL GREATER_THAN NOT_EQUAL UNIT_TYPE_HERO UNIT_TYPE_DEAD UNIT_TYPE_STRUCTURE  UNIT_TYPE_FLYING UNIT_TYPE_GROUND  UNIT_TYPE_ATTACKS_FLYING UNIT_TYPE_ATTACKS_GROUND  UNIT_TYPE_MELEE_ATTACKER UNIT_TYPE_RANGED_ATTACKER
syn keyword jassConstant	UNIT_TYPE_GIANT UNIT_TYPE_SUMMONED UNIT_TYPE_STUNNED UNIT_TYPE_PLAGUED UNIT_TYPE_SNARED UNIT_TYPE_UNDEAD UNIT_TYPE_MECHANICAL UNIT_TYPE_PEON UNIT_TYPE_SAPPER UNIT_TYPE_TOWNHALL UNIT_TYPE_ANCIENT UNIT_TYPE_TAUREN UNIT_TYPE_POISONED UNIT_TYPE_POLYMORPHED UNIT_TYPE_SLEEPING UNIT_TYPE_RESISTANT UNIT_TYPE_ETHEREAL UNIT_TYPE_MAGIC_IMMUNE ITEM_TYPE_PERMANENT ITEM_TYPE_CHARGED ITEM_TYPE_POWERUP ITEM_TYPE_ARTIFACT ITEM_TYPE_PURCHASABLE ITEM_TYPE_CAMPAIGN ITEM_TYPE_MISCELLANEOUS
syn keyword jassConstant	ITEM_TYPE_UNKNOWN ITEM_TYPE_ANY ITEM_TYPE_POWERUP ITEM_TYPE_TOME CAMERA_FIELD_TARGET_DISTANCE CAMERA_FIELD_FARZ CAMERA_FIELD_ANGLE_OF_ATTACK CAMERA_FIELD_FIELD_OF_VIEW CAMERA_FIELD_ROLL CAMERA_FIELD_ROTATION CAMERA_FIELD_ZOFFSET BLEND_MODE_NONE BLEND_MODE_DONT_CARE BLEND_MODE_KEYALPHA BLEND_MODE_BLEND BLEND_MODE_ADDITIVE BLEND_MODE_MODULATE BLEND_MODE_MODULATE_2X  RARITY_FREQUENT RARITY_RARE  TEXMAP_FLAG_NONE TEXMAP_FLAG_WRAP_U TEXMAP_FLAG_WRAP_V TEXMAP_FLAG_WRAP_UV
syn keyword jassConstant	FOG_OF_WAR_MASKED FOG_OF_WAR_FOGGED FOG_OF_WAR_VISIBLE CAMERA_MARGIN_LEFT CAMERA_MARGIN_RIGHT CAMERA_MARGIN_TOP CAMERA_MARGIN_BOTTOM EFFECT_TYPE_EFFECT EFFECT_TYPE_TARGET EFFECT_TYPE_CASTER EFFECT_TYPE_SPECIAL EFFECT_TYPE_AREA_EFFECT EFFECT_TYPE_MISSILE EFFECT_TYPE_LIGHTNING SOUND_TYPE_EFFECT SOUND_TYPE_EFFECT_LOOPED bj_PI bj_E bj_CELLWIDTH bj_CLIFFHEIGHT bj_UNIT_FACING bj_RADTODEG bj_DEGTORAD bj_TEXT_DELAY_QUEST bj_TEXT_DELAY_QUESTUPDATE bj_TEXT_DELAY_QUESTDONE
syn keyword jassConstant	bj_TEXT_DELAY_QUESTFAILED bj_TEXT_DELAY_QUESTREQUIREMENT bj_TEXT_DELAY_MISSIONFAILED bj_TEXT_DELAY_ALWAYSHINT bj_TEXT_DELAY_HINT bj_TEXT_DELAY_SECRET bj_TEXT_DELAY_UNITACQUIRED bj_TEXT_DELAY_UNITAVAILABLE bj_TEXT_DELAY_ITEMACQUIRED bj_TEXT_DELAY_WARNING bj_QUEUE_DELAY_QUEST bj_QUEUE_DELAY_HINT bj_QUEUE_DELAY_SECRET bj_HANDICAP_EASY bj_GAME_STARTED_THRESHOLD bj_WAIT_FOR_COND_MIN_INTERVAL bj_POLLED_WAIT_INTERVAL bj_POLLED_WAIT_SKIP_THRESHOLD bj_MAX_INVENTORY bj_MAX_PLAYERS bj_PLAYER_NEUTRAL_VICTIM
syn keyword jassConstant	bj_PLAYER_NEUTRAL_EXTRA bj_MAX_PLAYER_SLOTS bj_MAX_SKELETONS bj_MAX_STOCK_ITEM_SLOTS bj_MAX_STOCK_UNIT_SLOTS bj_MAX_ITEM_LEVEL bj_TOD_DAWN bj_TOD_DUSK bj_MELEE_STARTING_GOLD_V0 bj_MELEE_STARTING_GOLD_V1 bj_MELEE_STARTING_LUMBER_V0 bj_MELEE_STARTING_LUMBER_V1 bj_MELEE_STARTING_HERO_TOKENS bj_MELEE_HERO_LIMIT bj_MELEE_HERO_TYPE_LIMIT bj_MELEE_MINE_SEARCH_RADIUS bj_MELEE_CLEAR_UNITS_RADIUS bj_MELEE_CRIPPLE_TIMEOUT bj_MELEE_CRIPPLE_MSG_DURATION bj_MELEE_MAX_TWINKED_HEROES_V0 bj_MELEE_MAX_TWINKED_HEROES_V1
syn keyword jassConstant	bj_CREEP_ITEM_DELAY bj_STOCK_RESTOCK_INITIAL_DELAY bj_STOCK_RESTOCK_INTERVAL bj_STOCK_MAX_ITERATIONS bj_MAX_DEST_IN_REGION_EVENTS bj_CAMERA_MIN_FARZ bj_CAMERA_DEFAULT_DISTANCE bj_CAMERA_DEFAULT_FARZ bj_CAMERA_DEFAULT_AOA bj_CAMERA_DEFAULT_FOV bj_CAMERA_DEFAULT_ROLL bj_CAMERA_DEFAULT_ROTATION bj_RESCUE_PING_TIME bj_NOTHING_SOUND_DURATION bj_TRANSMISSION_PING_TIME bj_TRANSMISSION_IND_RED bj_TRANSMISSION_IND_BLUE bj_TRANSMISSION_IND_GREEN bj_TRANSMISSION_IND_ALPHA bj_TRANSMISSION_PORT_HANGTIME
syn keyword jassConstant	bj_CINEMODE_INTERFACEFADE bj_CINEMODE_GAMESPEED bj_CINEMODE_VOLUME_UNITMOVEMENT bj_CINEMODE_VOLUME_UNITSOUNDS bj_CINEMODE_VOLUME_COMBAT bj_CINEMODE_VOLUME_SPELLS bj_CINEMODE_VOLUME_UI bj_CINEMODE_VOLUME_MUSIC bj_CINEMODE_VOLUME_AMBIENTSOUNDS bj_CINEMODE_VOLUME_FIRE bj_SPEECH_VOLUME_UNITMOVEMENT bj_SPEECH_VOLUME_UNITSOUNDS bj_SPEECH_VOLUME_COMBAT bj_SPEECH_VOLUME_SPELLS bj_SPEECH_VOLUME_UI bj_SPEECH_VOLUME_MUSIC bj_SPEECH_VOLUME_AMBIENTSOUNDS bj_SPEECH_VOLUME_FIRE bj_SMARTPAN_TRESHOLD_PAN
syn keyword jassConstant	bj_SMARTPAN_TRESHOLD_SNAP bj_MAX_QUEUED_TRIGGERS bj_QUEUED_TRIGGER_TIMEOUT bj_CAMPAIGN_INDEX_T bj_CAMPAIGN_INDEX_H bj_CAMPAIGN_INDEX_U bj_CAMPAIGN_INDEX_O bj_CAMPAIGN_INDEX_N bj_CAMPAIGN_INDEX_XN bj_CAMPAIGN_INDEX_XH bj_CAMPAIGN_INDEX_XU bj_CAMPAIGN_INDEX_XO bj_CAMPAIGN_OFFSET_H bj_CAMPAIGN_OFFSET_U bj_CAMPAIGN_OFFSET_O bj_CAMPAIGN_OFFSET_N bj_CAMPAIGN_OFFSET_XN bj_CAMPAIGN_OFFSET_XH bj_CAMPAIGN_OFFSET_XU bj_CAMPAIGN_OFFSET_XO bj_MISSION_INDEX_T00 bj_MISSION_INDEX_T01 bj_MISSION_INDEX_H00
syn keyword jassConstant	bj_MISSION_INDEX_H01 bj_MISSION_INDEX_H02 bj_MISSION_INDEX_H03 bj_MISSION_INDEX_H04 bj_MISSION_INDEX_H05 bj_MISSION_INDEX_H06 bj_MISSION_INDEX_H07 bj_MISSION_INDEX_H08 bj_MISSION_INDEX_H09 bj_MISSION_INDEX_H10 bj_MISSION_INDEX_H11 bj_MISSION_INDEX_U00 bj_MISSION_INDEX_U01 bj_MISSION_INDEX_U02 bj_MISSION_INDEX_U03 bj_MISSION_INDEX_U05 bj_MISSION_INDEX_U07 bj_MISSION_INDEX_U08 bj_MISSION_INDEX_U09 bj_MISSION_INDEX_U10 bj_MISSION_INDEX_U11 bj_MISSION_INDEX_O00 bj_MISSION_INDEX_O01 bj_MISSION_INDEX_O02
syn keyword jassConstant	bj_MISSION_INDEX_O03 bj_MISSION_INDEX_O04 bj_MISSION_INDEX_O05 bj_MISSION_INDEX_O06 bj_MISSION_INDEX_O07 bj_MISSION_INDEX_O08 bj_MISSION_INDEX_O09 bj_MISSION_INDEX_O10 bj_MISSION_INDEX_N00 bj_MISSION_INDEX_N01 bj_MISSION_INDEX_N02 bj_MISSION_INDEX_N03 bj_MISSION_INDEX_N04 bj_MISSION_INDEX_N05 bj_MISSION_INDEX_N06 bj_MISSION_INDEX_N07 bj_MISSION_INDEX_N08 bj_MISSION_INDEX_N09 bj_MISSION_INDEX_XN00 bj_MISSION_INDEX_XN01 bj_MISSION_INDEX_XN02 bj_MISSION_INDEX_XN03 bj_MISSION_INDEX_XN04 bj_MISSION_INDEX_XN05
syn keyword jassConstant	bj_MISSION_INDEX_XN06 bj_MISSION_INDEX_XN07 bj_MISSION_INDEX_XN08 bj_MISSION_INDEX_XN09 bj_MISSION_INDEX_XN10 bj_MISSION_INDEX_XH00 bj_MISSION_INDEX_XH01 bj_MISSION_INDEX_XH02 bj_MISSION_INDEX_XH03 bj_MISSION_INDEX_XH04 bj_MISSION_INDEX_XH05 bj_MISSION_INDEX_XH06 bj_MISSION_INDEX_XH07 bj_MISSION_INDEX_XH08 bj_MISSION_INDEX_XH09 bj_MISSION_INDEX_XU00 bj_MISSION_INDEX_XU01 bj_MISSION_INDEX_XU02 bj_MISSION_INDEX_XU03 bj_MISSION_INDEX_XU04 bj_MISSION_INDEX_XU05 bj_MISSION_INDEX_XU06 bj_MISSION_INDEX_XU07
syn keyword jassConstant	bj_MISSION_INDEX_XU08 bj_MISSION_INDEX_XU09 bj_MISSION_INDEX_XU10 bj_MISSION_INDEX_XU11 bj_MISSION_INDEX_XU12 bj_MISSION_INDEX_XU13 bj_MISSION_INDEX_XO00 bj_CINEMATICINDEX_TOP bj_CINEMATICINDEX_HOP bj_CINEMATICINDEX_HED bj_CINEMATICINDEX_OOP bj_CINEMATICINDEX_OED bj_CINEMATICINDEX_UOP bj_CINEMATICINDEX_UED bj_CINEMATICINDEX_NOP bj_CINEMATICINDEX_NED bj_CINEMATICINDEX_XOP bj_CINEMATICINDEX_XED bj_ALLIANCE_UNALLIED bj_ALLIANCE_UNALLIED_VISION bj_ALLIANCE_ALLIED bj_ALLIANCE_ALLIED_VISION bj_ALLIANCE_ALLIED_UNITS
syn keyword jassConstant	bj_ALLIANCE_ALLIED_ADVUNITS bj_ALLIANCE_NEUTRAL bj_ALLIANCE_NEUTRAL_VISION bj_KEYEVENTTYPE_DEPRESS bj_KEYEVENTTYPE_RELEASE bj_KEYEVENTKEY_LEFT bj_KEYEVENTKEY_RIGHT bj_KEYEVENTKEY_DOWN bj_KEYEVENTKEY_UP bj_TIMETYPE_ADD bj_TIMETYPE_SET bj_TIMETYPE_SUB bj_CAMERABOUNDS_ADJUST_ADD bj_CAMERABOUNDS_ADJUST_SUB bj_QUESTTYPE_REQ_DISCOVERED bj_QUESTTYPE_REQ_UNDISCOVERED bj_QUESTTYPE_OPT_DISCOVERED bj_QUESTTYPE_OPT_UNDISCOVERED bj_QUESTMESSAGE_DISCOVERED bj_QUESTMESSAGE_UPDATED bj_QUESTMESSAGE_COMPLETED bj_QUESTMESSAGE_FAILED
syn keyword jassConstant	bj_QUESTMESSAGE_REQUIREMENT bj_QUESTMESSAGE_MISSIONFAILED bj_QUESTMESSAGE_ALWAYSHINT bj_QUESTMESSAGE_HINT bj_QUESTMESSAGE_SECRET bj_QUESTMESSAGE_UNITACQUIRED bj_QUESTMESSAGE_UNITAVAILABLE bj_QUESTMESSAGE_ITEMACQUIRED bj_QUESTMESSAGE_WARNING bj_SORTTYPE_SORTBYVALUE bj_SORTTYPE_SORTBYPLAYER bj_SORTTYPE_SORTBYLABEL bj_CINEFADETYPE_FADEIN bj_CINEFADETYPE_FADEOUT bj_CINEFADETYPE_FADEOUTIN bj_REMOVEBUFFS_POSITIVE bj_REMOVEBUFFS_NEGATIVE bj_REMOVEBUFFS_ALL bj_REMOVEBUFFS_NONTLIFE bj_BUFF_POLARITY_POSITIVE
syn keyword jassConstant	bj_BUFF_POLARITY_NEGATIVE bj_BUFF_POLARITY_EITHER bj_BUFF_RESIST_MAGIC bj_BUFF_RESIST_PHYSICAL bj_BUFF_RESIST_EITHER bj_BUFF_RESIST_BOTH bj_HEROSTAT_STR bj_HEROSTAT_AGI bj_HEROSTAT_INT bj_MODIFYMETHOD_ADD bj_MODIFYMETHOD_SUB bj_MODIFYMETHOD_SET bj_UNIT_STATE_METHOD_ABSOLUTE bj_UNIT_STATE_METHOD_RELATIVE bj_UNIT_STATE_METHOD_DEFAULTS bj_UNIT_STATE_METHOD_MAXIMUM bj_GATEOPERATION_CLOSE bj_GATEOPERATION_OPEN bj_GATEOPERATION_DESTROY bj_GAMECACHE_BOOLEAN bj_GAMECACHE_INTEGER bj_GAMECACHE_REAL bj_GAMECACHE_UNIT
syn keyword jassConstant	bj_GAMECACHE_STRING bj_HASHTABLE_BOOLEAN bj_HASHTABLE_INTEGER bj_HASHTABLE_REAL bj_HASHTABLE_STRING bj_HASHTABLE_HANDLE bj_ITEM_STATUS_HIDDEN bj_ITEM_STATUS_OWNED bj_ITEM_STATUS_INVULNERABLE bj_ITEM_STATUS_POWERUP bj_ITEM_STATUS_SELLABLE bj_ITEM_STATUS_PAWNABLE bj_ITEMCODE_STATUS_POWERUP bj_ITEMCODE_STATUS_SELLABLE bj_ITEMCODE_STATUS_PAWNABLE bj_MINIMAPPINGSTYLE_SIMPLE bj_MINIMAPPINGSTYLE_FLASHY bj_MINIMAPPINGSTYLE_ATTACK bj_CORPSE_MAX_DEATH_TIME bj_CORPSETYPE_FLESH bj_CORPSETYPE_BONE bj_ELEVATOR_BLOCKER_CODE
syn keyword jassConstant	bj_ELEVATOR_CODE01 bj_ELEVATOR_CODE02 bj_ELEVATOR_WALL_TYPE_ALL bj_ELEVATOR_WALL_TYPE_EAST bj_ELEVATOR_WALL_TYPE_NORTH bj_ELEVATOR_WALL_TYPE_SOUTH bj_ELEVATOR_WALL_TYPE_WEST bj_FORCE_ALL_PLAYERS bj_FORCE_PLAYER bj_MELEE_MAX_TWINKED_HEROES bj_mapInitialPlayableArea bj_mapInitialCameraBounds bj_forLoopAIndex bj_forLoopBIndex bj_forLoopAIndexEnd bj_forLoopBIndexEnd bj_slotControlReady bj_slotControlUsed bj_slotControl bj_gameStartedTimer bj_gameStarted bj_volumeGroupsTimer bj_isSinglePlayer bj_dncSoundsDay
syn keyword jassConstant	bj_dncSoundsNight bj_dayAmbientSound bj_nightAmbientSound bj_dncSoundsDawn bj_dncSoundsDusk bj_dawnSound bj_duskSound bj_useDawnDuskSounds bj_dncIsDaytime bj_rescueSound bj_questDiscoveredSound bj_questUpdatedSound bj_questCompletedSound bj_questFailedSound bj_questHintSound bj_questSecretSound bj_questItemAcquiredSound bj_questWarningSound bj_victoryDialogSound bj_defeatDialogSound bj_stockItemPurchased bj_stockUpdateTimer bj_stockAllowedPermanent bj_stockAllowedCharged bj_stockAllowedArtifact
syn keyword jassConstant	bj_stockPickedItemLevel bj_stockPickedItemType bj_meleeVisibilityTrained bj_meleeVisibilityIsDay bj_meleeGrantHeroItems bj_meleeNearestMineToLoc bj_meleeNearestMine bj_meleeNearestMineDist bj_meleeGameOver bj_meleeDefeated bj_meleeVictoried bj_ghoul bj_crippledTimer bj_crippledTimerWindows bj_playerIsCrippled bj_playerIsExposed bj_finishSoonAllExposed bj_finishSoonTimerDialog bj_meleeTwinkedHeroes bj_rescueUnitBehavior bj_rescueChangeColorUnit bj_rescueChangeColorBldg bj_cineSceneEndingTimer
syn keyword jassConstant	bj_cineSceneLastSound bj_cineSceneBeingSkipped bj_cineModePriorSpeed bj_cineModePriorFogSetting bj_cineModePriorMaskSetting bj_cineModeAlreadyIn bj_cineModePriorDawnDusk bj_cineModeSavedSeed bj_cineFadeFinishTimer bj_cineFadeContinueTimer bj_cineFadeContinueRed bj_cineFadeContinueGreen bj_cineFadeContinueBlue bj_cineFadeContinueTrans bj_cineFadeContinueDuration bj_cineFadeContinueTex bj_queuedExecTotal bj_queuedExecTriggers bj_queuedExecUseConds bj_queuedExecTimeoutTimer bj_queuedExecTimeout
syn keyword jassConstant	bj_destInRegionDiesCount bj_destInRegionDiesTrig bj_groupCountUnits bj_forceCountPlayers bj_groupEnumTypeId bj_groupEnumOwningPlayer bj_groupAddGroupDest bj_groupRemoveGroupDest bj_groupRandomConsidered bj_groupRandomCurrentPick bj_groupLastCreatedDest bj_randomSubGroupGroup bj_randomSubGroupWant bj_randomSubGroupTotal bj_randomSubGroupChance bj_destRandomConsidered bj_destRandomCurrentPick bj_elevatorWallBlocker bj_elevatorNeighbor bj_itemRandomConsidered bj_itemRandomCurrentPick bj_forceRandomConsidered
syn keyword jassConstant	bj_forceRandomCurrentPick bj_makeUnitRescuableUnit bj_makeUnitRescuableFlag bj_pauseAllUnitsFlag bj_enumDestructableCenter bj_enumDestructableRadius bj_setPlayerTargetColor bj_isUnitGroupDeadResult bj_isUnitGroupEmptyResult bj_isUnitGroupInRectResult bj_isUnitGroupInRectRect bj_changeLevelShowScores bj_changeLevelMapName bj_suspendDecayFleshGroup bj_suspendDecayBoneGroup bj_delayedSuspendDecayTimer bj_delayedSuspendDecayTrig bj_livingPlayerUnitsTypeId bj_lastDyingWidget bj_randDistCount bj_randDistID
syn keyword jassConstant	bj_randDistChance bj_lastCreatedUnit bj_lastCreatedItem bj_lastRemovedItem bj_lastHauntedGoldMine bj_lastCreatedDestructable bj_lastCreatedGroup bj_lastCreatedFogModifier bj_lastCreatedEffect bj_lastCreatedWeatherEffect bj_lastCreatedTerrainDeformation bj_lastCreatedQuest bj_lastCreatedQuestItem bj_lastCreatedDefeatCondition bj_lastStartedTimer bj_lastCreatedTimerDialog bj_lastCreatedLeaderboard bj_lastCreatedMultiboard bj_lastPlayedSound bj_lastPlayedMusic bj_lastTransmissionDuration bj_lastCreatedGameCache
syn keyword jassConstant	bj_lastCreatedHashtable bj_lastLoadedUnit bj_lastCreatedButton bj_lastReplacedUnit bj_lastCreatedTextTag bj_lastCreatedLightning bj_lastCreatedImage bj_lastCreatedUbersplat filterIssueHauntOrderAtLocBJ filterEnumDestructablesInCircleBJ filterGetUnitsInRectOfPlayer filterGetUnitsOfTypeIdAll filterGetUnitsOfPlayerAndTypeId filterMeleeTrainedUnitIsHeroBJ filterLivingPlayerUnitsOfTypeId bj_wantDestroyGroup bj_initialPlayableMapArea PLAYER_NEUTRAL_PASSIVE PLAYER_NEUTRAL_AGGRESIVE PLAYER_COLOR_RED PLAYER_COLOR_BLUE
syn keyword jassConstant        PLAYER_COLOR_CYAN PLAYER_COLOR_PURPLE PLAYER_COLOR_YELLOW PLAYER_COLOR_ORANGE PLAYER_COLOR_GREEN PLAYER_COLOR_PINK PLAYER_COLOR_LIGHT_GRAY PLAYER_COLOR_LIGHT_BLUE PLAYER_COLOR_AQUA PLAYER_COLOR_BROWN RACE_HUMAN RACE_ORC RACE_UNDEAD RACE_NIGHTELF RACE_DEMON RACE_OTHER PLAYER_GAME_RESULT_VICTORY PLAYER_GAME_RESULT_DEFEAT PLAYER_GAME_RESULT_TIE PLAYER_GAME_RESULT_NEUTRAL ALLIANCE_PASSIVE ALLIANCE_HELP_REQUEST ALLIANCE_HELP_RESONSE ALLIANCE_SHARED_XP ALLIANCE_SHARED_SPELLS ALLIANCE_SHARED_VISION ALLIANCE_SHARED_CONTROL
syn keyword jassConstant        ALLIANCE_SHARED_ADVANCED_CONTROL ALLIANCE_RESCUABLE ALLIANCE_SHARED_VISION_FORCED VERSION_REIGN_OF_CHAOS VERSION_FROZEN_THRONE ATTACK_TYPE_NORMAL ATTACK_TYPE_MELEE ATTACK_TYPE_PIERCE ATTACK_TYPE_SIEGE ATTACK_TYPE_MAGIC ATTACK_TYPE_CHAOS ATTACK_TYPE_HERO DAMAGE_TYPE_UNKNOWN DAMAGE_TYPE_NORMAL DAMAGE_TYPE_ENHANCED DAMAGE_TYPE_FIRE DAMAGE_TYPE_COLD DAMAGE_TYPE_LIGHTNING DAMAGE_TYPE_POISON DAMAGE_TYPE_DISEASE DAMAGE_TYPE_DIVINE DAMAGE_TYPE_MAGIC DAMAGE_TYPE_SONIC DAMAGE_TYPE_ACID

syn keyword jassTrueFalse   true
syn keyword jassTrueFalse   false
syn keyword jassThis        this

syn match jassReplace "\$[^$]*\$"

syn match jassRawCode "'[^'][^'][^'][^']'"
syn match jassChar    "'[^']'"

" Define the default highlighting.
" For version 5.7 and earlier: only when not done already
" For version 5.8 and later: only when an item doesn't have highlighting yet
if version >= 508 || !exists("did_jass_syntax_inits")
  if version < 508
    let did_jass_syntax_inits = 1
    command -nargs=+ HiLink hi link <args>
  else
    command -nargs=+ HiLink hi def link <args>
  endif

  " The default methods for highlighting.  Can be overridden later
  
  HiLink jassTrueFalse Value
  HiLink jassThis      Statement
  HiLink jassRawCode   RawCode
  HiLink jassChar      Char
  HiLink jassIdentifier Normal
  HiLink jassRepeat	Block
  HiLink jassStatement	Statement
  HiLink jassLabel	Block
  HiLink jassComment	Comment
  HiLink jassPreprocessor	 vJASSPreproc
  HiLink jassPreprocessorKeyword Statement
  HiLink jassConstant	Constant
  "  HiLink jassDirective	Statement

  HiLink jassCond	Block

  HiLink jassFunc	Block

  HiLink vjassStruct    Struct

  HiLink hexNumber	Number
  HiLink decNumber	Number
  HiLink octNumber	Number
  HiLink binNumber	Number


  "HiLink jassIdentifier Identifier
  HiLink jassType	Type
  HiLink jassString String
  HiLink jassOperator Operator
  HiLink jassCondOperator CondOperator
  HiLink jassBraces Braces
  HiLink jassReplace Preproc

  "HiLink Natives and BJ's
  HiLink jassNative    Native
  HiLink jassBJ 	BJ

  " My default color overrides:
  " hi jassSpecialComment ctermfg=red
  " hi jassIdentifier ctermfg=lightcyan
  " hi jassType ctermbg=black ctermfg=brown

  delcommand HiLink
endif

set wrap	nowrap
set ai
let b:current_syntax = "jass"

" vim: ts=8
